--[[ This program is freeware; you may give it away and/or change it
under the GNU General Public License.  However, there is no
warrenty; not even an implied one.  When I say warrenty, you
say, "None!"  Also of note is that only the source code is
licensed under the GNU General Public License.  The art cannot
be edited, changed, or included with other programs.

The other software that this program uses is under a copyright
from the people whom wrote it, mostly being a variation on the
zlib license.
For more information on the license, check the COPYING file
included with this program, or look on the GNU website,
www.gnu.org ]]

--[[
  What this file contains:
  * Code for animating the background.
]]

Background = {}
local gf = love.graphics
function Background.new()
  local group = {}
  group.tileWidth = 64
  group.tileHeight = 64
  group.offset_y = 64
  group.image = "images/water_deep.png"
  mr_framebuffer = pcall(love.graphics.newFramebuffer, gf.getWidth()+50, gf.getHeight()+50)

  -- Sheesh, I didn't know I would do all of this
  -- manipulation of the offset_y variable.
  function group.getOffset()
   return group.offset_y
  end

  function group.setOffset(number)
   group.offset_y = number
  end

  function group.subtractFromOffset(number)
   group.offset_y = group.offset_y - number
  end

  function group.addToOffset(number)
   group.offset_y = group.offset_y + number
  end

  -- Actually draw the waves over and over,
  -- like an animation.
  function group.draw_waves(image1)
    -- First set the framebuffer
    if mr_framebuffer then
      gf.setRenderTarget(mr_framebuffer)
    end
    
    for x =0,13 do
      for y = 0,14 do
        gf.draw(image1, x*group.tileWidth, y*group.tileHeight-group.offset_y)
      end
    end
    
    -- Now draw the contents of the framebuffer.
    if mr_framebuffer then
      gf.setRenderTarget()
      gf.draw(mr_framebuffer, 0, 0, 0)
    end    
  end
  
  function group:update(changeInTime)
       -- Subtract from the offset so as to
     -- make the wave tiles look like they're
     -- moving.
     group.subtractFromOffset(700*changeInTime)

     -- Check the background tiling offset
     -- and change it accordingly.
     if group.getOffset() <= 0 then
       group.setOffset(64)
     end
  end
  return group
end