--[[ This program is freeware; you may give it away and/or change it
under the GNU General Public License.  However, there is no
warrenty; not even an implied one.  When I say warrenty, you
say, "None!"  Also of note is that only the source code is
licensed under the GNU General Public License.  The art cannot
be edited, changed, or included with other programs.

The other software that this program uses is under a copyright
from the people whom wrote it, mostly being a variation on the
zlib license or BSD license.
For more information on the license, check the COPYING file
included with this program, or look on the GNU website,
www.gnu.org ]]

--[[
What is contained in this file:
  * Code for fading-in from the menu.
]]--

 -- Based upon fader code from Thomas Holden.
fader = {}
local gf = love.graphics

function fader:new()
 local object = {
   finished = false,
   increments = -128,  -- As the name implies, you add or subtract to this to figure out how much transparency has been applied.
   color = {
    -- Define some colors
    red = 0,
    green = 0,
    blue = 0,
    alpha = 255
   },
   temporaryColor = {
    red = 0,
    green = 0,
    blue = 0,
    alpha = 0
   }
 }
 
 function object:draw()
   if object.color.alpha ~= 0 then
     object.temporaryColor.red, object.temporaryColor.green, object.temporaryColor.blue, object.temporaryColor.alpha = gf.getColor() -- remember the previous colors.
     gf.setColor(object.color.red, object.color.green, object.color.blue, object.color.alpha) -- Set the colors currently saved
     gf.rectangle("fill", 0, 0, gf.getWidth(), gf.getHeight()) -- Create a rectanlge with the current alpha
     gf.setColor(object.temporaryColor.red, object.temporaryColor.green, object.temporaryColor.blue, object.temporaryColor.alpha) -- Set the color with the temporary colors... For some reason.
   end
 end

 function object:update(changeInTime)
   if not object.finished then
     object.color.alpha = object.color.alpha + (object.increments * changeInTime) -- Change the alpha, at our own pace.
     -- Don't go over board (or underboard) with the alpha.
     if object.increments < 0 and object.color.alpha <= 0 then
       object.color.alpha = 0 -- Alpha stays at zer0.
       object.finished = true
       object:changeColor(0,0,0) -- Reset the color when we're done.
     elseif object.increments > 0 and object.color.alpha >= 255 then
       object.color.alpha = 255 -- Alpha stays at 255.
       object.finished = true
       object:changeColor(0,0,0) -- Reset the color when we're done.
     end
   end
 end
 
 -- Use this to, what else?, change the color.
 function object:changeColor(red, green, blue)
   object.color.red = red or 0
   object.color.green = green or 0
   object.color.blue = blue or 0
 end

 function object:doFadeIn()
   
 end
 
 return object
end