--[[ This program is freeware; you may give it away and/or change it
under the GNU General Public License.  However, there is no
warrenty; not even an implied one.  When I say warrenty, you
say, "None!"  Also of note is that only the source code is
licensed under the GNU General Public License.  The art cannot
be edited, changed, or included with other programs.

The other software that this program uses is under a copyright
from the people whom wrote it, mostly being a variation on the
zlib license or BSD license.
For more information on the license, check the COPYING file
included with this program, or look on the GNU website,
www.gnu.org ]]

-- The majority of the code is from the game Cannon Ship.

  --[[ What is contained in this file:
	* Start menu
	* Credits menu
	* Instructions menu
  ]]--

Menus = {}
local gf = love.graphics -- Wow, I use this a lot.

function Menus.new()

 local object = {}

 object.displayCredits = false
 object.displayInstructions = false
 object.startFadining = false
 object.letsGetThePartyStarted = false

 object.index = 1
 object.MenuSelections = {}
 object.youAreHere = 'top'

 -- I wish I could figure out this piece of code. :-(
 function object.keypressed(key, unicode)
  if key == 'up' then
    if object.index > 1 then
      print("Subtracting from index.") -- Debugging
      object.index = object.index - 1
    end
  elseif key == 'down' then
    if object.index < #object.MenuSelections then
      print("Adding to index.")
      object.index = object.index + 1
    end
  elseif key == 'return' then
    object.goDeeper()
  end
 end

 -- This is for putting in the proper menus into the table which
 -- populates the menu.
 function object.putInMenuSelections()
   for i=1,#object.MenuSelections do
     table.remove(object.MenuSelections,1) -- Replace the menu selections with something else.
   end
   if object.youAreHere == 'top' then
     table.insert(object.MenuSelections, "Start Game")
     table.insert(object.MenuSelections, "Credits")  -- Need to fix this.
     table.insert(object.MenuSelections, "Instructions") -- Show instructions and stuff.
     table.insert(object.MenuSelections, "Quit Game")
   elseif object.youAreHere == 'Credits' then
     table.insert(object.MenuSelections, "Go back to Main Screen")
   elseif object.youAreHere == 'Instructions' then
     table.insert(object.MenuSelections, "Go back to Main Screen")
   end
   
 end

 -- As the name implies, this is for drawing the menu options
 -- to the screen.  Just be sure to put it in the love.draw() step.
 function object.draw()
   for i=1,#object.MenuSelections do
     if i == object.index then
       gf.setColor(244, 255, 32, 255)
     else
       gf.setColor(63, 159, 255, 255)
     end
     gf.print(object.MenuSelections[i], gf.getWidth()/2, (gf.getHeight()/2)+32*i) -- Boy, was the cursor hard to implement.
     -- This is for the instructions
     if object.displayInstructions then
      object.showInstructions()
     -- This is for the credits.
     elseif object.displayCredits then
       object.showCredits()
     end
   end
 end

 
 -- This is for navigating the submenus.
 function object.goDeeper()
   local le_selection = object.MenuSelections[object.index]
   if le_selection == 'Go back to Main Screen' then
     object.youAreHere = 'top' -- Go back to the top.
     -- Check the toggle variables for the other menus and flip them off if necessary.
     if object.displayCredits then
       object.displayCredits = false
     elseif object.displayInstructions then
       object.displayInstructions = false
     end
   elseif le_selection == "Credits" then
     object.displayCredits = true -- Display the credits.     
     object.youAreHere = 'Credits'
   elseif le_selection == "Instructions" then
     object.displayInstructions = true -- Display the instructions
     object.youAreHere = 'Instructions'
   elseif le_selection == 'Quit Game' then -- Exit the game
     love.event.push('q')
   -- This is for updating the alpha channels so as to fade-in to the main game.
   elseif le_selection == 'Start Game' then
       object.letsGetThePartyStarted = true -- Start the game
       -- Change the color so that the rest of the in-game colors
       -- aren't messed up.
       gf.setColor(255,255,255,255)
   end
 end

 function object.showInstructions()
   gf.setColor(15, 255, 215, 255)
   gf.printf("Use the arrow keys or the \"WASD\" keys to move the ship.  Tap the space bar or left-click the mouse button to shoot bullets.", gf.getHeight()*0.25, gf.getHeight()*0.25, 500, "left")
 end
 
 function object.showCredits()
   gf.setColor(15,255,215, 255)
   gf.printf("This demo was made by a guy sitting in his room,\n typing away at his laptop.", gf.getWidth()*0.25, gf.getHeight()*0.25, 400, "left")
 end

 return object
end
