--[[ This program is freeware; you may give it away and/or change it
under the GNU General Public License.  However, there is no
warrenty; not even an implied one.  When I say warrenty, you
say, "None!"  Also of note is that only the source code is
licensed under the GNU General Public License.  The art cannot
be edited, changed, or included with other programs.

The other software that this program uses is under a copyright
from the people whom wrote it, mostly being a variation on the
zlib license or the BSD license.

For more information on the license, check the COPYING file
included with this program, or look on the GNU website,
www.gnu.org
]]

--[[
  What is contained in this file:
  * The code to move the hero ship.
  * Code to fire hero's weapons.
]]

Movement = {}

function Movement.new()

 heroMovement = {}

 -- Some variables we must objectify.
 local keyboard = love.keyboard
 local SCREENWIDTH = love.graphics.getWidth()
 local SCREENHEIGHT = love.graphics.getHeight()

 -- Move the hero on the x-axis.
 function heroMovement.moveOnXaxis( x,speed, changeInTime )
   if keyboard.isDown("right") or keyboard.isDown("d") then
    x = x + (speed * changeInTime)
     -- Keep them in bounds.  Use the width of the image as an offset.
    if x > SCREENWIDTH-64
     then x = SCREENWIDTH-64
    end
   elseif keyboard.isDown("left") or keyboard.isDown("a") then
    x = x - (speed * changeInTime)
    -- Keep them in bounds.
    if x < 0 then
     x = 0
    end
   end

   return x
 end

 -- Move the hero on the y-axis.
 function heroMovement.moveOnYaxis(y, speed, changeInTime)
  if keyboard.isDown("down") or keyboard.isDown("s") then
    y = y + (speed * changeInTime)
    -- Keep them in bounds
    if y > SCREENHEIGHT-64 then y = SCREENHEIGHT-64 end
  elseif keyboard.isDown("up") or keyboard.isDown("w") then
    y = y - (speed * changeInTime)
    -- Keep them in bounds.
    if y < 0 then y = 0 end
  end
  return y
 end

 -- This is suppose to be the function that animates the hero as
 -- it moves on to the screen.

 --[[ If hasFinishedMoving == false then (keep moving) elseif hasFinishedMoving == true then (move
 on to normal ship movements) ]]
 heroMovement.distanceCovered = 0
 heroMovement.inc = 1.5
--[[ function heroMovement.bigOpening(hamster,speed,changeInTime)
   -- Make certain that this variable only goes up to a certain value.
   if heroMovement.distanceCovered <= (0.9 * SCREENHEIGHT) then
     heroMovement.distanceCovered = heroMovement.distanceCovered + (speed * changeInTime * heroMovement.inc)
   end
   if heroMovement.distanceCovered >= (0.9 * SCREENHEIGHT) then
     -- Move the ship down at a normal pace.  This step is done second.
     hamster.y = heroMovement.distanceCovered
     hamster.y = hamster.y + (speed * changeInTime)
   else
     -- Move the speed up quickly.  This step is done first.
     hamster.y = hamster.y - (speed * changeInTime * heroMovement.inc)
   end
 end  ]]
 function heroMovement.bigOpening(hamster, speed, changeInTime)
   if hamster.y >= (SCREENHEIGHT/2) then
     hamster.y = hamster.y - (speed * changeInTime * 2.1)
   else
     heroMovement.hasFinishedMoving = true
   end
 end

 heroMovement.hasFinishedMoving = false

 -- Return the class.
 return heroMovement
end